/*
 () 
e-mail: liloi@mail.ru
07/05/06

[dekart].x - x-   
[dekart].y - y-   

[polar].ro -   ()   
[polar].fi - ,    () 

dek_to_pol(...)  pol_to_dek(...) -     
 . . dek_to_pol     (x   
 0, ,    , ""  .  
 ,     .      
(arctg(x)  2 )   ()  .  
  -  .

range_pol(...) -      .

add_angle(...) -    .  :   :

    polar a;
    a.ro = 3;
    a.fi = M_PI;

    a.fi += M_PI/2;

:  :-)   :      ,   
( ) .      ,    .

*/

#ifndef L_POLAR
#define L_POLAR

#include <math.h>

struct polar
{
    double ro;
    double fi;
};

struct dekart
{
    double x;
    double y;
};


dekart pol_to_dek(polar a);


polar add_angle(polar a, double ang)
{
    a.fi += ang;
    re:if(fabs(a.fi)>(2*M_PI))
    {
        if(a.fi>=0)a.fi -= 2*M_PI; else a.fi += 2*M_PI;
        goto re;
    }
    return a;
}


double range_pol(polar a, polar b)
{
    
    dekart aa = pol_to_dek(a);
    dekart bb = pol_to_dek(b);
    
    dekart c;
    c.x = fabs(aa.x-bb.x);
    c.y = fabs(aa.y-bb.y);
    
    double ret = pow(pow(c.x,2)+pow(c.y,2),0.5);
    return ret;
}


dekart pol_to_dek(polar a)
{
    dekart ret;
    ret.x = a.ro*cos(a.fi);
    ret.y = a.ro*sin(a.fi);
    return ret;
}


dekart pol_to_dek(double ro, double fi)
{
    dekart ret;
    ret.x = ro*cos(fi);
    ret.y = ro*sin(fi);
    return ret;
}


polar dek_to_pol(dekart a) // !!!
{
    polar ret;
    ret.ro = pow((pow(a.x,2)+pow(a.y,2)),0.5);

    double z = atan(a.y/a.x);
    
    if((pol_to_dek(ret.ro,z).x!=a.x)&&(pol_to_dek(ret.ro,z).y!=a.y))
        z += M_PI;
        
    ret.fi = z;
    
    return ret;
}


polar dek_to_pol(double x, double y) // !!!
{
    polar ret;
    ret.ro = pow((pow(x,2)+pow(y,2)),0.5);

    double z = atan(y/x);
    
    if((pol_to_dek(ret.ro,z).x!=x)&&(pol_to_dek(ret.ro,z).y!=y))
        z += M_PI;
    
    ret.fi = z;
    
    return ret;
}

#endif

//


